#!/bin/bash

# $Id: logoutkill.sh,v 1.1.1.1 2004/01/30 21:35:06 pere Exp $
# This script could be run from /etc/kde2/kdm/Xreset by adding the line 
# '/usr/local/sbin/logoutkill.sh $USER'
# right before the line 
# 'exit 0'


KEEPONES="root USER daemon"
USERLIMIT=10000

if [ -f /etc/skolelinux/logoutkill.conf ] ; then 
  . /etc/skolelinux/logoutkill.conf
fi 

for EVERY in $KEEPONES ; do 
  KEEP="${KEEP:+$KEEP|}^$EVERY"
done

USER=$1

if [ -z "$USER" ] ; then 
  echo -e "usage:\n\t$0 <username>"
  exit 0
fi

ps auxw | grep ^$USER | grep -vE $KEEP | \
  while read PUSER PID NULL ; do 
    [ "$PUSER" = "$USER" -a $(id -u $PUSER) -ge $USERLIMIT ] && kill $PID ; 
  done

sleep 10
  
ps auxw | grep ^$USER | grep -vE $KEEP | \
  while read PUSER PID NULL ; do 
    [ "$PUSER" = "$USER" -a $(id -u $PUSER) -ge $USERLIMIT ] && kill -9 $PID ; 
  done
