#!/bin/bash

# $Id: nightkill.sh,v 1.1.1.1 2004/01/30 21:35:06 pere Exp $
# This script could be run every night, to kill stray processes. 

KEEPONES="root USER daemon"
USERLIMIT=10000

if [ -f /etc/skolelinux/nightkill.conf ] ; then 
  . /etc/skolelinux/nightkill.conf
fi 

for EVERY in $KEEPONES ; do 
  KEEP="${KEEP:+$KEEP|}^$EVERY"
done


ps auxw | grep -vE $KEEP | \
  while read PUSER PID NULL ; do 
    [ $(id -u $PUSER) -ge $USERLIMIT ] && kill $PID ; 
  done

sleep 10
  
ps auxw | grep -vE $KEEP | \
  while read PUSER PID NULL ; do 
    [ $(id -u $PUSER) -ge $USERLIMIT ] && kill -9 $PID ; 
  done
